## ngcp-sems 1.6.0+0~mr14.0.1.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)

IF(COMMAND cmake_policy)
	# Don't do automatic escaping of variables
	CMAKE_POLICY(SET CMP0005 OLD)
	CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy)


# Add path for additional FindXXX.cmake scenarios
set( CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

PROJECT (SEMS)

SET(SEMS_MAJOR_VERSION 1)
SET(SEMS_MINOR_VERSION 6)
SET(SEMS_BUILD_VERSION 0)
SET(SEMS_EXTRA_VERSION dev)

IF(EXISTS ${CMAKE_SOURCE_DIR}/.git)
	SET(SEMS_VERSION
	    "${SEMS_MAJOR_VERSION}.${SEMS_MINOR_VERSION}.${SEMS_BUILD_VERSION}-${SEMS_EXTRA_VERSION}")
ELSE(EXISTS ${CMAKE_SOURCE_DIR}/.git)
	SET(SEMS_VERSION
	    "${SEMS_MAJOR_VERSION}.${SEMS_MINOR_VERSION}.${SEMS_BUILD_VERSION}")
ENDIF(EXISTS ${CMAKE_SOURCE_DIR}/.git)

MESSAGE(STATUS "Configuring ${CMAKE_PROJECT_NAME} v. ${SEMS_VERSION}")

SET(SEMS_APP_NAME "sems")

IF(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR AND NOT MSVC_IDE)
	message(FATAL_ERROR "In-source builds are not allowed.
CMake would overwrite all makefiles distributed with SEMS.
Please create a directory and run cmake from there, passing the path
to this source directory as the last argument.
This process created the file `CMakeCache.txt' and the directory `CMakeFiles'.
Please delete them.")
ENDIF(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR AND NOT MSVC_IDE)

OPTION(SEMS_USE_SPANDSP       "Build with spandsp" OFF)
OPTION(SEMS_USE_LIBSAMPLERATE "Build with libsamplerate" OFF)
OPTION(SEMS_USE_ZRTP          "Build with ZRTP" OFF)
OPTION(SEMS_USE_MP3           "Build with Lame MP3" OFF)
OPTION(SEMS_USE_ILBC          "Build with iLBC library (fallback to bundled)" ON)
OPTION(SEMS_USE_TTS           "Build with Text-to-speech support (requires Flite)" OFF)
OPTION(SEMS_USE_OPENSSL       "Build with OpenSSL" OFF)
OPTION(SEMS_USE_MONITORING    "Build with monitoring support" OFF)
OPTION(SEMS_USE_IPV6          "Build with IPv6 support" OFF)
OPTION(MAX_RTP_SESSIONS:int   "How many rtp sessions SEMS will handle simultaneously? (default 2048)" 2048)

# Fix weird static libs handling in old CMake
IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STREQUAL "2.4")
	SET(SEMS_WORKAROUND_FOR_OLD_CMAKE_2_4_FOR_STATIC_LIBS  ON)
ELSE (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STREQUAL "2.4")
	SET(SEMS_WORKAROUND_FOR_OLD_CMAKE_2_4_FOR_STATIC_LIBS  OFF)
ENDIF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STREQUAL "2.4")

# add -lm and -lpthread to all targets
SET(CMAKE_DL_LIBS ${CMAKE_DL_LIBS} m pthread)

IF (NOT SEMS_CFG_PREFIX)
	SET(SEMS_CFG_PREFIX "/usr/local")
ENDIF (NOT SEMS_CFG_PREFIX)
MESSAGE(STATUS "SEMS cfg prefix was set to: ${SEMS_CFG_PREFIX}")

IF (NOT SEMS_AUDIO_PREFIX)
	SET(SEMS_AUDIO_PREFIX "/usr/local/lib")
ENDIF (NOT SEMS_AUDIO_PREFIX)
MESSAGE(STATUS "SEMS audio prefix was set to: ${SEMS_AUDIO_PREFIX}")

IF (NOT SEMS_EXEC_PREFIX)
	SET(SEMS_EXEC_PREFIX "/usr/local")
ENDIF (NOT SEMS_EXEC_PREFIX)
MESSAGE(STATUS "SEMS exec prefix was set to: ${SEMS_EXEC_PREFIX}")

IF (NOT SEMS_LIBDIR)
	SET(SEMS_LIBDIR "lib")
ENDIF (NOT SEMS_LIBDIR)
MESSAGE(STATUS "SEMS libdir was set to: ${SEMS_LIBDIR}")

IF (NOT SEMS_DOC_PREFIX)
	SET(SEMS_DOC_PREFIX "/usr/share/doc")
ENDIF (NOT SEMS_DOC_PREFIX)
MESSAGE(STATUS "SEMS doc prefix was set to: ${SEMS_DOC_PREFIX}")

SET(CMAKE_VERBOSE_MAKEFILE ON)

FIND_PACKAGE(Libevent2 REQUIRED)

# compile with spandsp DTMF detection? see soft-switch.org
#   this needs a fairly new version of spandsp - tested with 0.0.4pre11
#   will not work with spandsp 0.0.2 .
#   (which means that current debian and gentoo packages don't work)
IF(SEMS_USE_SPANDSP)
	FIND_PACKAGE(Spandsp REQUIRED)
	ADD_DEFINITIONS(-DUSE_SPANDSP -D__STDC_LIMIT_MACROS)
	MESSAGE(STATUS "Using spandsp: YES")
ELSE(SEMS_USE_SPANDSP)
	MESSAGE(STATUS "Using spandsp: NO (default)")
ENDIF(SEMS_USE_SPANDSP)

# compile with sample rate conversion from secret rabbit code?
# (see http://www.mega-nerd.com/SRC/)
IF(SEMS_USE_LIBSAMPLERATE)
	FIND_PACKAGE(Libsamplerate REQUIRED)
	ADD_DEFINITIONS(-DUSE_LIBSAMPLERATE)
	MESSAGE(STATUS "Using libsamplerate: YES")
ELSE(SEMS_USE_LIBSAMPLERATE)
	MESSAGE(STATUS "Using libsamplerate: NO (default)")
ENDIF(SEMS_USE_LIBSAMPLERATE)

# ZRTP support? (see zfoneproject.com)
IF(SEMS_USE_ZRTP)
	FIND_PACKAGE(Libzrtp REQUIRED)
	MESSAGE(STATUS "Using libzrtp: YES")
	ADD_DEFINITIONS(-DWITH_ZRTP -DBUILD_ZRTP_MUTEXES -DBUILD_DEFAULT_CACHE -DBUILD_DEFAULT_TIMER -DUNIX -DBUILD_ZRTP_MUTEXES)
ELSE(SEMS_USE_ZRTP)
	MESSAGE(STATUS "Using libzrtp: NO (default)")
ENDIF(SEMS_USE_ZRTP)

# Lame MP3 support
IF(SEMS_USE_MP3)
	FIND_PACKAGE(Lame REQUIRED)
	MESSAGE(STATUS "Using lame mp3: YES")
ELSE(SEMS_USE_MP3)
	MESSAGE(STATUS "Using lame mp3: NO (default)")
ENDIF(SEMS_USE_MP3)

IF(SEMS_USE_ILBC)
	FIND_PACKAGE(Ilbc)
	IF(ILBC_FOUND)
		MESSAGE(STATUS "Using iLBC library: YES (external)")
	ELSE(ILBC_FOUND)
		MESSAGE(STATUS "Using iLBC library: YES (bundled, default)")
	ENDIF(ILBC_FOUND)
ELSE(SEMS_USE_ILBC)
	MESSAGE(STATUS "Uusing iLBC library: NO")
ENDIF(SEMS_USE_ILBC)

# build in support for monitoring?
IF(SEMS_USE_MONITORING)
	MESSAGE(STATUS "Enable monitoring: YES")
	ADD_DEFINITIONS(-DUSE_MONITORING)
ELSE(SEMS_USE_MONITORING)
	MESSAGE(STATUS "Enable monitoring: NO (default)")
ENDIF(SEMS_USE_MONITORING)

IF(SEMS_USE_IPV6)
	ADD_DEFINITIONS(-DSUPPORT_IPV6)
	MESSAGE(STATUS "Enable IPv6 support: YES")
ELSE(SEMS_USE_IPV6)
	MESSAGE(STATUS "Enable IPv6 support: NO (default)")
ENDIF(SEMS_USE_IPV6)

# Let's try to find GSM library and header files
FIND_PACKAGE(Gsm)
IF(GSM_FOUND)
	MESSAGE(STATUS "Using gsm: YES")
ELSE(GSM_FOUND)
	MESSAGE(STATUS "Using gsm: NO")
ENDIF(GSM_FOUND)

# Let's try to find SPEEX library and header files
FIND_PACKAGE(Speex)
IF(SPEEX_FOUND)
	MESSAGE(STATUS "Using speex: YES")
ELSE(SPEEX_FOUND)
	MESSAGE(STATUS "Using speex: NO")
ENDIF(SPEEX_FOUND)

IF(SEMS_USE_OPENSSL)
	FIND_PACKAGE(OpenSSL REQUIRED QUIETLY)
	MESSAGE(STATUS "Found OpenSSL includes:	${OPENSSL_INCLUDE_DIR}/openssl/ssl.h")
	MESSAGE(STATUS "Found OpenSSL library: ${OPENSSL_LIBRARIES}")
	MESSAGE(STATUS "Using OpenSSL: YES")
ELSE(SEMS_USE_OPENSSL)
	MESSAGE(STATUS "Using OpenSSL: NO (default)")
ENDIF(SEMS_USE_OPENSSL)

# Let's try to find Python development files
FIND_PACKAGE(PythonLibs)
IF(PYTHONLIBS_FOUND OR PYTHON_LIBRARIES)
	SET(PYTHONLIBS_FOUND TRUE)
	MESSAGE(STATUS "Found Python includes:	${PYTHON_INCLUDE_PATH}/Python.h")
	MESSAGE(STATUS "Found Python library: ${PYTHON_LIBRARIES}")
	MESSAGE(STATUS "Using Python: YES")
ELSE(PYTHONLIBS_FOUND OR PYTHON_LIBRARIES)
	MESSAGE(STATUS "Using Python: NO")
ENDIF(PYTHONLIBS_FOUND OR PYTHON_LIBRARIES)

# Let's try to find SIP (Python bindings generator) development files
FIND_PACKAGE(SIP)
IF(SIP_FOUND)
	MESSAGE(STATUS "Using SIP: YES")
ELSE(SIP_FOUND)
	MESSAGE(STATUS "Using SIP: NO")
ENDIF(SIP_FOUND)

# Let's try to find MySQL++ development files
FIND_PACKAGE(MySQLpp)
IF(MYSQLPP_FOUND)
	MESSAGE(STATUS "Using MySQL++: YES")
ELSE(MYSQLPP_FOUND)
	MESSAGE(STATUS "Using MySQL++: NO")
ENDIF(MYSQLPP_FOUND)

# Let's try to find Flite library and header files
IF(SEMS_USE_TTS)
	FIND_PACKAGE(Flite REQUIRED)
	MESSAGE(STATUS "Using text-to-speech: YES")
ELSE(SEMS_USE_TTS)
	SET(FLITE_FOUND FALSE)
	MESSAGE(STATUS "Using text-to-speech: NO (default)")
ENDIF(SEMS_USE_TTS)

# Let's try to find mISDN library and header files
FIND_PACKAGE(MISDN)
IF(MISDN_FOUND)
	MESSAGE(STATUS "Using mISDN: YES")
ELSE(MISDN_FOUND)
	MESSAGE(STATUS "Using mISDN: NO")
ENDIF(MISDN_FOUND)

# Let's try to find libev development files
FIND_PACKAGE(Libev)
IF(LIBEV_FOUND)
	MESSAGE(STATUS "Using libev: YES")
ELSE(LIBEV_FOUND)
	MESSAGE(STATUS "Using libev: NO")
ENDIF(LIBEV_FOUND)

# Let's try to find librtmp development files
FIND_PACKAGE(Librtmp)
IF(RTMP_FOUND)
	MESSAGE(STATUS "Using librtmp: YES")
ELSE(RTMP_FOUND)
	MESSAGE(STATUS "Using librtmp: NO")
ENDIF(RTMP_FOUND)

# Check for res_search in -lresolv
include(${CMAKE_SOURCE_DIR}/cmake/CheckSymbolExists.cmake)
SET(CMAKE_REQUIRED_LIBRARIES resolv)
CHECK_SYMBOL_EXISTS(res_search resolv.h HAVE_RES_SEARCH)
MESSAGE(STATUS "Have res_search: ${HAVE_RES_SEARCH} ")

INCLUDE_DIRECTORIES (${SEMS_SOURCE_DIR}/core/ampi)
INCLUDE_DIRECTORIES (${SEMS_SOURCE_DIR}/core/amci)
INCLUDE_DIRECTORIES (${SEMS_SOURCE_DIR}/core)

CONFIGURE_FILE( ${SEMS_SOURCE_DIR}/core/sems.h.cmake ${SEMS_SOURCE_DIR}/core/sems.h )

IF(CMAKE_COMPILER_IS_GNUCC)
	SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_THREAD_SAFE -D_REENTRANT -Wall -fPIC -g -O2")
ENDIF(CMAKE_COMPILER_IS_GNUCC)

IF(CMAKE_COMPILER_IS_GNUCXX)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_THREAD_SAFE -D_REENTRANT -Wall -Wno-reorder -fPIC -g -O2")
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")
SET(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   -D_DEBUG")

# compile with session thread pool support?
#      use this for very high concurrent call count
#      applications (e.g. for signaling only)
#      if compiled with thread pool, there will be a
#      thread pool of configurable size processing the
#      signaling and application logic of the calls.
#      if compiled without thread pool support, every
#      session will have its own thread.
#
#ADD_DEFINITIONS(-DSESSION_THREADPOOL)

#ADD_DEFINITIONS(-DNO_THREADID_LOG)
#ADD_DEFINITIONS(-DLOG_LOC_DATA_ATEND)

# Support for long debug messages? (useful for debugging SIP messages' contents)
#
# disable for slight performance gain
ADD_DEFINITIONS(-DLOG_BUFFER_LEN=2048)

#ADD_DEFINITIONS(-DDEBUG_PLAYOUTBUF)

SET(CMAKE_SHARED_LIBRARY_PREFIX "")

ADD_SUBDIRECTORY (core)
ADD_SUBDIRECTORY (apps)
ADD_SUBDIRECTORY (tools)

#SET_DIRECTORY_PROPERTIES(ADDITIONAL_MAKE_CLEAN_FILES *~)

=== Makefile ===
.DEFAULT_GOAL:=all

.PHONY: all
all: modules

COREPATH=core
include Makefile.defs

NAME=$(APP_NAME)

subdirs = core apps tools

.PHONY: clean
clean:
	@rm -f *.so
	@set -e; \
	for r in $(subdirs) doc "" ; do \
		if [ -n "$$r" ]; then \
			echo "" ; \
			echo "making $$r" ; \
			$(MAKE) -C $$r clean ; \
		fi ; \
	done
	rm -f t/*.so
	rm -rf t/run

.PHONY: modules
modules:
	@set -e; \
	for r in $(subdirs) "" ; do \
		if [ -n "$$r" ]; then \
			echo  "" ; \
			echo  "making $$r" ; \
			$(MAKE) -C $$r all; \
		fi ; \
	done 

.PHONY: install
install: modules
	@set -e; \
	for r in $(subdirs) "" ; do \
		if [ -n "$$r" ]; then \
			echo "" ; \
			echo "" ; \
			$(MAKE) -C $$r install; \
		fi ; \
	done
	@echo ""
	@echo "*** install complete. Run SEMS with "
	@echo "*** "
	@echo "***   $(bin_target)$(NAME) -f $(cfg_target)sems.conf"


.PHONY: dist
dist: tar

.PHONY: tar
tar: 
	$(TAR) -C .. \
		--exclude=$(notdir $(CURDIR))/tmp \
		--exclude=core/$(notdir $(CURDIR))/tmp \
		--exclude=.svn* \
		--exclude=.git* \
		--exclude=.\#* \
		--exclude=*.[do] \
		--exclude=*.la \
		--exclude=*.lo \
		--exclude=*.so \
		--exclude=*.il \
		--exclude=*.gz \
		--exclude=*.bz2 \
		--exclude=*.tar \
		--exclude=*~ \
		-cf - $(notdir $(CURDIR)) | \
			(mkdir -p tmp/_tar1; mkdir -p tmp/_tar2 ; \
			    cd tmp/_tar1; $(TAR) -xf - ) && \
			    mv tmp/_tar1/$(notdir $(CURDIR)) \
			       tmp/_tar2/"$(NAME)-$(RELEASE)" && \
			    (cd tmp/_tar2 && $(TAR) \
			                    -zcf ../../"$(NAME)-$(RELEASE)".tar.gz \
			                               "$(NAME)-$(RELEASE)" ) ; \
			    rm -rf tmp

# the rpmtar target creates source tar.gz file, with versions taken from rpm spec file
# the tarball can be used for rpm building 
.PHONY: rpmtar
rpmtar: 
	RPM_VERSION=`cat pkg/rpm/sems.spec|grep -e "^Version:"|awk '{print $$2}'`; \
	RPM_RELEASE=`cat pkg/rpm/sems.spec|grep -e "^Release:"|awk '{print $$2}'`; \
	echo "RPM_VERSION=$${RPM_VERSION}"; \
	echo "RPM_RELEASE=$${RPM_RELEASE}"; \
	        $(TAR) -C .. \
                --exclude=$(notdir $(CURDIR))/tmp \
                --exclude=core/$(notdir $(CURDIR))/tmp \
                --exclude=.svn* \
                --exclude=.git* \
                --exclude=.\#* \
                --exclude=*.[do] \
                --exclude=*.la \
                --exclude=*.lo \
                --exclude=*.so \
                --exclude=*.il \
                --exclude=*.gz \
                --exclude=*.bz2 \
                --exclude=*.tar \
                --exclude=*~ \
                -cf - $(notdir $(CURDIR)) | \
                        (mkdir -p tmp/_tar1; mkdir -p tmp/_tar2 ; \
                            cd tmp/_tar1; $(TAR) -xf - ) && \
                            mv tmp/_tar1/$(notdir $(CURDIR)) \
                               tmp/_tar2/"$(NAME)-$${RPM_VERSION}" && \
                            (cd tmp/_tar2 && $(TAR) \
                                            -zcf ../../"$(NAME)-$${RPM_VERSION}-$${RPM_RELEASE}".tar.gz \
                                                       "$(NAME)-$${RPM_VERSION}" ) ; \
                            rm -rf tmp;
  
.PHONY: doc
doc:
	$(MAKE) -C doc/ doc

.PHONY: fulldoc
fulldoc:
	$(MAKE) -C doc/ fulldoc

.PHONY: check
check:
	$(MAKE) t/tests-preload.so
	rm -rf t/run
	mkdir t/run
	for X in t/test-*.py; do t/auto-test-helper $$(basename "$$X") "core/$(NAME)" "$$X" || exit 1; done

t/tests-preload.so: t/tests-preload.c
	$(CC) -g -pthread -D_GNU_SOURCE -std=c11 -o $@ -shared -fPIC $< -ldl -lm

=== apps/CMakeLists.txt ===
ADD_SUBDIRECTORY(ann_b2b)
ADD_SUBDIRECTORY(announce_transfer)
ADD_SUBDIRECTORY(announcement)
ADD_SUBDIRECTORY(annrecorder)
ADD_SUBDIRECTORY(callback)
ADD_SUBDIRECTORY(click2dial)
IF(PYTHONLIBS_FOUND)
	ADD_SUBDIRECTORY(conf_auth)
ENDIF(PYTHONLIBS_FOUND)
ADD_SUBDIRECTORY(conference)
IF(MYSQLPP_FOUND)
	ADD_SUBDIRECTORY(db_reg_agent)
ENDIF(MYSQLPP_FOUND)
IF(OPENSSL_FOUND)
	ADD_SUBDIRECTORY(diameter_client)
ENDIF(OPENSSL_FOUND)
ADD_SUBDIRECTORY(dsm)
ADD_SUBDIRECTORY(early_announce)
#ADD_SUBDIRECTORY(examples)
IF(MISDN_FOUND)
#	ADD_SUBDIRECTORY(gateway)
ENDIF(MISDN_FOUND)
IF(PYTHONLIBS_FOUND)
	ADD_SUBDIRECTORY(ivr)
ENDIF(PYTHONLIBS_FOUND)
IF(LIBEV_FOUND)
	ADD_SUBDIRECTORY(jsonrpc)
ENDIF(LIBEV_FOUND)
IF(PYTHONLIBS_FOUND)
	ADD_SUBDIRECTORY(mailbox)
ENDIF(PYTHONLIBS_FOUND)
ADD_SUBDIRECTORY(monitoring)
IF(LAME_FOUND)
	ADD_SUBDIRECTORY(mp3)
ENDIF(LAME_FOUND)
ADD_SUBDIRECTORY(msg_storage)
ADD_SUBDIRECTORY(mwi)
IF(PYTHONLIBS_FOUND)
	ADD_SUBDIRECTORY(pin_collect)
ENDIF(PYTHONLIBS_FOUND)
ADD_SUBDIRECTORY(precoded_announce)
IF(PYTHONLIBS_FOUND)
IF(SIP_FOUND)
	ADD_SUBDIRECTORY(py_sems)
ENDIF(SIP_FOUND)
ENDIF(PYTHONLIBS_FOUND)
ADD_SUBDIRECTORY(reg_agent)
ADD_SUBDIRECTORY(registrar_client)
IF(RTMP_FOUND)
	ADD_SUBDIRECTORY(rtmp)
ENDIF(RTMP_FOUND)
ADD_SUBDIRECTORY(sbc)
IF(PYTHONLIBS_FOUND)
#	ADD_SUBDIRECTORY(twit)
ENDIF(PYTHONLIBS_FOUND)
ADD_SUBDIRECTORY(voicebox)
ADD_SUBDIRECTORY(voicemail)
ADD_SUBDIRECTORY(webconference)
IF(OPENSSL_FOUND)
	ADD_SUBDIRECTORY(xmlrpc2di)
ENDIF(OPENSSL_FOUND)

=== apps/Makefile ===
COREPATH ?= ../core
.DEFAULT_GOAL := all

local_exclude_app_modules=confpin early_dbprompt mobile_push py_sems gateway twit

include $(COREPATH)/../Makefile.defs


# modules...

# if app_modules is set 
#   make $(app_modules)
# else 
#   if exclude_app_modules is set
#     make * - $(exclude_app_modules) + local excludes
#   else
#     make * - Makefile.defs:exclude_app_modules +  local excludes
#   

ifeq ($(app_modules),)

 ifeq ($(exclude_app_modules),)
  exclude_app_modules = ann_b2b announce_transfer announcement annrecorder callback callqueues conference confpin conf_auth diameter_client dimanagedha early_announce early_dbprompt examples examples/tutorial/cc_acc gateway ivr jsonrpc mailbox memcachedstore mobile_push mp3 msg_storage mwi pin_collect precoded_announce py_sems rtmp twit voicebox voicemail webconference
 endif

 ifeq ($(TEST_ENVIRONMENT),yes)
  exclude_app_modules = ann_b2b announce_transfer announcement annrecorder callback callqueues conference confpin conf_auth diameter_client dimanagedha early_announce early_dbprompt examples examples/tutorial/cc_acc gateway ivr jsonrpc mailbox memcachedstore mobile_push mp3 msg_storage mwi pin_collect precoded_announce py_sems rtmp twit voicebox voicemail webconference sw_rating sw_vsc
 endif

 exclude_modules = $(exclude_app_modules)
 exclude_modules += $(local_exclude_app_modules)

 ifneq ($(USE_MONITORING), yes)
 exclude_modules += monitoring
 endif

 $(info local_exclude_app_modules: $(local_exclude_app_modules))
 $(info exclude_app_modules: $(exclude_app_modules))
 app_modules = $(filter-out $(subst ;, ,$(exclude_modules)) \
		$(wildcard Makefile*) CVS CMakeLists.txt, \
		$(wildcard *) examples/tutorial/cc_acc )

endif


$(info app_modules: $(app_modules))

.PHONY: all
all: modules

.PHONY: clean
clean:
	@rm -f *.so
	@set -e; \
	for r in $(app_modules) "" ; do \
		if [ -n "$$r" ]; then \
			echo "" ; \
			echo "Cleaning $$r" ; \
			echo "" ; \
			COREPATH=../$(COREPATH) $(MAKE) -C $$r clean ; \
		fi ; \
	done

.PHONY: modules
modules:
	@set -e; \
	for r in $(app_modules) "" ; do \
		if [ -n "$$r" ]; then \
			echo  "" ; \
			echo "Making $$r" ; \
			echo  "" ; \
			COREPATH=../$(COREPATH) $(MAKE) -C $$r all; \
		fi ; \
	done 

.PHONY: install
install: install-bin

.PHONY: install-bin
install-bin: modules
	@set -e; \
	for r in $(app_modules) "" ; do \
		if [ -n "$$r" ]; then \
			echo "" ; \
			echo "Installing $$r binaries" ; \
			echo "" ; \
			COREPATH=../$(COREPATH) $(MAKE) -C $$r install; \
		fi ; \
	done

.PHONY: install-cfg
install-cfg: $(DESTDIR)$(cfg_target)
	@set -e; \
	for r in $(app_modules) "" ; do \
		if [ -n "$$r" ]; then \
			echo "" ; \
			echo "Installing $$r configuration" ; \
			echo "" ; \
			COREPATH=../$(COREPATH) $(MAKE) -C $$r install-cfg; \
		fi ; \
	done

=== core/CMakeLists.txt ===
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/audio.rules.txt)

FILE (GLOB sems_SRCS "*.cpp" "sip/*.cpp")

set (audio_files
beep.wav
default_en.wav
)

INCLUDE_DIRECTORIES (ampi)
INCLUDE_DIRECTORIES (amci)

ADD_EXECUTABLE (sems ${sems_SRCS})
TARGET_LINK_LIBRARIES(sems ${CMAKE_DL_LIBS} stdc++ resolv)

IF(NOT MAX_RTP_SESSIONS)
	SET(MAX_RTP_SESSIONS 2048)
ENDIF(NOT MAX_RTP_SESSIONS)

ADD_DEFINITIONS(-DMAX_RTP_SESSIONS=${MAX_RTP_SESSIONS})

TARGET_LINK_LIBRARIES(sems ${CMAKE_DL_LIBS} event event_pthreads)

IF(SPANDSP_FOUND)
	TARGET_LINK_LIBRARIES(sems ${CMAKE_DL_LIBS} spandsp)
ENDIF(SPANDSP_FOUND)

IF(LIBSAMPLERATE_FOUND)
	TARGET_LINK_LIBRARIES(sems ${CMAKE_DL_LIBS} samplerate)
ENDIF(LIBSAMPLERATE_FOUND)

IF(LIBZRTP_FOUND)
	TARGET_LINK_LIBRARIES(sems ${CMAKE_DL_LIBS} zrtp)
ENDIF(LIBZRTP_FOUND)

ADD_SUBDIRECTORY(plug-in)

# Create config-file from template
CONFIGURE_FILE (${CMAKE_SOURCE_DIR}/core/etc/app_mapping.conf.sample ${CMAKE_SOURCE_DIR}/core/etc/app_mapping.conf)
CONFIGURE_FILE (${CMAKE_SOURCE_DIR}/core/etc/sems.conf.cmake ${CMAKE_SOURCE_DIR}/core/etc/sems.conf)

# Installation of main SEMS executable
INSTALL(TARGETS sems RUNTIME DESTINATION ${SEMS_EXEC_PREFIX}/sbin)

# Installation of config-files
INSTALL(FILES ./etc/sems.conf DESTINATION ${SEMS_CFG_PREFIX}/etc/sems/)
INSTALL(FILES ./etc/app_mapping.conf DESTINATION ${SEMS_CFG_PREFIX}/etc/sems/etc/)
IF(LIBZRTP_FOUND)
INSTALL(FILES ./etc/zrtp.conf DESTINATION ${SEMS_CFG_PREFIX}/etc/sems/etc/)
ENDIF(LIBZRTP_FOUND)

INCLUDE(${CMAKE_SOURCE_DIR}/cmake/doc.rules.txt)

SET(doc_dirs ../doc/figures)
SET(doc_files
	../doc/Applications.txt
	../doc/Howtostart_noproxy.txt
	../doc/Howtostart_simpleproxy.txt
	../doc/Howtostart_voicemail.txt
	../doc/CHANGELOG
	../doc/COPYING
	../doc/Tuning.txt
)

SEMS_INSTALL_DOCS("${doc_files}" "${doc_dirs}")
SEMS_INSTALL_AUDIO("" "${audio_files}")

=== core/Makefile ===
APP_NAME ?= sems
NAME=$(APP_NAME)
LIBNAME=$(APP_NAME).so

COREPATH=.

PLUGIN_DIR=plug-in
SIP_STACK_DIR=sip
RESAMPLE_DIR=resample

SRCS=$(wildcard *.cpp)
HDRS=$(SRCS:.cpp=.h)
OBJS=$(SRCS:.cpp=.o)
DEPS=$(SRCS:.cpp=.d) $(NAME).d
AUDIO_FILES=$(notdir $(wildcard wav/*.wav))
TEST_DIR=tests

.PHONY: all
all: ../Makefile.defs $(NAME) modules

.PHONY: clean
clean:
	@rm -f $(OBJS) $(DEPS) $(NAME)
	@rm -f lib/*.so compat/getos compat/getarch
	@$(MAKE) -C $(SIP_STACK_DIR) clean
	@$(MAKE) -C $(RESAMPLE_DIR) clean
	@$(MAKE) -C $(PLUGIN_DIR) clean

.PHONY: sip_stack
sip_stack:
	@echo ""
	@echo "making SIP stack"
	@cd $(SIP_STACK_DIR); $(MAKE) all

.PHONY: modules
modules:
	@echo ""
	@echo "making core modules"
	@cd $(PLUGIN_DIR); $(MAKE) modules

.PHONY: test
test:
	@echo ""
	@echo "making tests"
	@cd $(TEST_DIR); $(MAKE)

.PHONY: core
core: $(OBJS) ../Makefile.defs

include ../Makefile.defs

CPPFLAGS += -I$(COREPATH) -fno-strict-aliasing
LDFLAGS += -levent -levent_pthreads  -lssl -lcrypto -lsystemd

ifdef USE_LIBSAMPLERATE
CPPFLAGS += -DUSE_LIBSAMPLERATE
LDFLAGS +=-lsamplerate
endif

# This allows symbols defined in the SIP stack but not used
# by the core itself to be included in the executable and
# thus be available for modules
ifneq ($(LD), clang)
EXTRA_LDFLAGS += -Wl,--whole-archive $(SIP_STACK_DIR)/sip_stack.a -Wl,--no-whole-archive
else
EXTRA_LDFLAGS += -force_load $(SIP_STACK_DIR)/sip_stack.a
endif

ifneq ($(OS), freebsd)
	EXTRA_LDFLAGS += -lresolv
endif


ifdef USE_INTERNAL_RESAMPLER

CPPFLAGS += -DUSE_INTERNAL_RESAMPLER
OBJS += $(RESAMPLE_DIR)/libresample.a

.PHONY: resample_lib
resample_lib:
	@echo ""
	@echo "making internal resampler"
	@cd $(RESAMPLE_DIR); $(MAKE) all

else

.PHONY: resample_lib
resample_lib:

endif

ifeq ($(USE_GPERFTOOLS),yes)
LDFLAGS += -ltcmalloc -lprofiler
endif

ifdef USE_SPANDSP
CPPFLAGS += -DUSE_SPANDSP -D__STDC_LIMIT_MACROS

ifdef LIBSPANDSP_STATIC
LDFLAGS += $(LIBSPANDSP_LDIR)libspandsp.a
else
LDFLAGS += -lspandsp
endif
endif

-include $(DEPS)

# implicit rules
%.o : %.cpp ../Makefile.defs
	$(CXX) -MMD -c -o $@ $< $(CPPFLAGS) $(CXXFLAGS)

$(NAME): sip_stack resample_lib core ../Makefile.defs
	@echo ""
	@echo "making $(NAME) executable"
	$(LD) -o $(NAME) $(OBJS) $(LDFLAGS) $(EXTRA_LDFLAGS)


install: mk-install-dirs
	$(MAKE) install-audio install-bin install-modules


# note: on solaris 8 sed: ? or \(...\)* (a.s.o) do not work
install-cfg: $(DESTDIR)$(cfg_target) $(DESTDIR)$(app_cfg_target)
		sed -e "s#/usr/.*lib/sems/audio/#$(audio_target)#g" \
			-e "s#/usr/.*lib/sems/plug-in/#$(modules_target)#g" \
			-e "s#/usr/.*etc/sems/#$(cfg_target)#g" \
			< etc/sems.conf.sample > $(DESTDIR)$(cfg_target)sems.conf.default
		chmod 644 $(DESTDIR)$(cfg_target)sems.conf.default
		if [ ! -f $(DESTDIR)$(cfg_target)sems.conf ]; then \
			cp -f $(DESTDIR)$(cfg_target)sems.conf.default \
				$(DESTDIR)$(cfg_target)sems.conf; \
		fi

		$(INSTALL_CFG) etc/app_mapping.conf.sample $(DESTDIR)$(app_cfg_target)app_mapping.conf

install-bin: $(NAME) $(DESTDIR)$(bin_prefix)/$(bin_dir)
		$(INSTALL_BIN) $(NAME) $(DESTDIR)$(bin_prefix)/$(bin_dir)

install-modules: modules $(PLUGIN_DIR) $(DESTDIR)$(modules_prefix)/$(modules_dir)
	$(MAKE) -C $(PLUGIN_DIR) install

install-modules-cfg: $(PLUGIN_DIR) 
	$(MAKE) -C $(PLUGIN_DIR) install-cfg

install-audio: $(DESTDIR)$(audio_prefix)/$(audio_dir)
	for f in $(AUDIO_FILES) ; do \
		if [ -n "wav/$$f" ]; then \
			$(INSTALL_AUDIO) wav/$$f $(DESTDIR)$(audio_prefix)/$(audio_dir)$$f; \
		fi ; \
	done

dist: tar

tar: 
	$(TAR) -C .. \
		--exclude=$(notdir $(CURDIR))/ivr \
		--exclude=$(notdir $(CURDIR))/tmp \
		--exclude=.svn* \
		--exclude=.\#* \
		--exclude=*.[do] \
		--exclude=*.la \
		--exclude=*.lo \
		--exclude=*.so \
		--exclude=*.il \
		--exclude=$(notdir $(CURDIR))/sems \
		--exclude=$(notdir $(CURDIR))/build-stamp \
		--exclude=$(notdir $(CURDIR))/configure-stamp \
		--exclude=$(notdir $(CURDIR))/debian/sems-core \
		--exclude=*.gz \
		--exclude=*.bz2 \
		--exclude=*.tar \
		--exclude=*~ \
		-cf - $(notdir $(CURDIR)) | \
			(mkdir -p tmp/_tar1; mkdir -p tmp/_tar2 ; \
			    cd tmp/_tar1; $(TAR) -xf - ) && \
			    mv tmp/_tar1/$(notdir $(CURDIR)) \
			       tmp/_tar2/"$(NAME)-$(RELEASE)" && \
			    (cd tmp/_tar2 && $(TAR) \
			                    -zcf ../../"$(NAME)-$(notdir $(CURDIR))-$(RELEASE)".tar.gz \
			                               "$(NAME)-$(RELEASE)" ) ; \
			    rm -rf tmp/_tar1; rm -rf tmp/_tar2

=== doc/Makefile ===


.PHONY: doc
doc:
	doxygen doxygen_proj

#	lynx -dump doxygen_doc/html/index.html >index.txt
#	lynx -dump doxygen_doc/html/howtostart_noproxy.html >Howtostart_noproxy.txt
#	lynx -dump doxygen_doc/html/howtostart_simpleproxy.html >Howtostart_simpleproxy.txt
#	lynx -dump doxygen_doc/html/howtostart_voicemail.html >Howtostart_voicemail.txt
#	lynx -dump doxygen_doc/html/AppDoc.html >Applications.txt
#	lynx -dump doxygen_doc/html/ZRTP.html >ZRTP.txt
#	lynx -dump doxygen_doc/html/Tuning.html >Tuning.txt
#	lynx -dump doxygen_doc/html/ComponentDoc.html >ComponentModules.txt


.PHONY: fulldoc
fulldoc:
	doxygen doxygen_fulldoc_proj

.PHONY: clean
clean:
	rm -Rf doxygen_doc doxygen_fulldoc 

.PHONY: txtdoc_clean
txtdoc_clean:
	rm -rf index.txt Howtostart_noproxy.txt Howtostart_simpleproxy.txt Howtostart_voicemail.txt Applications.txt ZRTP.txt Tuning.txt ComponentModules.txt

.PHONY: txtdoc
txtdoc: doc
	lynx -dump doxygen_doc/html/index.html >index.txt
	lynx -dump doxygen_doc/html/howtostart_noproxy.html >Howtostart_noproxy.txt
	lynx -dump doxygen_doc/html/howtostart_simpleproxy.html >Howtostart_simpleproxy.txt
	lynx -dump doxygen_doc/html/howtostart_voicemail.html >Howtostart_voicemail.txt
	lynx -dump doxygen_doc/html/AppDoc.html >Applications.txt
	lynx -dump doxygen_doc/html/ZRTP.html >ZRTP.txt
	lynx -dump doxygen_doc/html/Tuning.html >Tuning.txt
	lynx -dump doxygen_doc/html/ComponentDoc.html >ComponentModules.txt

=== tools/CMakeLists.txt ===
# executable

set (sems-logfile-callextract_SRCS
logfile-splitter.cpp
)

ADD_EXECUTABLE (sems-logfile-callextract ${sems-logfile-callextract_SRCS})
#TARGET_LINK_LIBRARIES(sems-stats ${CMAKE_DL_LIBS} stdc++)

INSTALL(TARGETS sems-logfile-callextract
        RUNTIME DESTINATION ${SEMS_EXEC_PREFIX}/sbin
        )

INCLUDE(${CMAKE_SOURCE_DIR}/cmake/config.rules.txt)

=== tools/Makefile ===
all: make_tools

COREPATH ?= ../core
include $(COREPATH)/../Makefile.defs

sems_tools = sems-logfile-callextract

install: install_tools

make_tools: $(sems_tools)

install_tools: make_tools $(DESTDIR)$(bin_prefix)/$(bin_dir)
	@set -e; \
	for r in $(sems_tools)  ; do \
		x=`echo $$r | sed s/sems-/$(APP_NAME)-/g` ; \
		echo "installing $$r -> $$x" ; \
		$(INSTALL_BIN) $$r $(DESTDIR)$(bin_prefix)/$(bin_dir)/$$x ; \
	done

sems-logfile-callextract: logfile-splitter.o
	$(LD) -o sems-logfile-callextract logfile-splitter.o -lstdc++

clean:
	rm -f logfile-splitter.o sems-logfile-callextract

=== apps/ann_b2b/CMakeLists.txt ===
set (ann_b2b_SRCS
AnnounceB2B.cpp
)

SET(sems_module_name ann_b2b)
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/module.rules.txt)

=== apps/ann_b2b/Makefile ===
plug_in_name = ann_b2b

module_ldflags =
module_cflags  = 

extra_install = $(plug_in_name)_audio

COREPATH ?=../../core
include $(COREPATH)/plug-in/Makefile.app_module

=== apps/announce_transfer/CMakeLists.txt ===
set (announce_transfer_SRCS
AnnounceTransfer.cpp
)

SET(sems_module_name announce_transfer)
INCLUDE(${CMAKE_SOURCE_DIR}/cmake/module.rules.txt)

=== debian/changelog ===
ngcp-sems (1:1.6.0+0~mr14.0.1.1) unstable; urgency=medium

  * New release.

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 09 Dec 2025 15:33:49 +0100

ngcp-sems (1:1.6.0+0~mr14.0.1.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [853a9fe] MT#62763 Fix shellcheck issues

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 24 Nov 2025 16:58:36 +0100

ngcp-sems (1:1.6.0+0~mr14.0.0.0) unstable; urgency=medium

  [ Richard Fuchs ]
  * [cab8463] MT#62181 pass strings by reference instead of copy
  * [80172e0] MT#62181 don't use string for bool value
  * [b7abe78] MT#62181 std::move updates
  * [e684718] MT#63171 StatsUDPServer: use correct FD flag
  * [4a4b8fe] MT#62181 StatsUDPServer: fix possible overrun
  * [a07dd24] MT#55283 flush stdout after config print
  * [1b33d02] MT#62181 removal from list with lock held
  * [1f709bb] MT#63171 AmThread: introduce lock & cond
  * [7c54980] MT#63171 proper shutdown of AmThreadWatcher
  * [f9faa2e] MT#62181 iterate list with lock held
  * [03c6196] MT#63171 join stopped thread
  * [392cd9d] MT#63171 StatsUDPServer: facilitate shutdown
  * [4bd36ff] MT#63171 Statistics: add dtor
  * [01345c6] MT#63171 AmSessionProcessor: use lock guard
  * [f9b93e3] MT#63171 add AmSessionProcessor::stopThreads
  * [cbb5a3a] MT#63171 AmSessionProcessorThread: replace runcond
  * [55a86bb] MT#63171 stop AmAppTimer on shutdown
  * [fe7e899] MT#63171 AmEventQueue: virtual inherit refcnt
  * [5234af1] MT#63171 generalise AmEventQueue
  * [ef2b5e4] MT#63171 introduce AmEventQueueThread
  * [1f5564a] MT#63171 AmCallWatcher: use AmEventQueueThread
  * [bd5462d] MT#63171 SIPRegistrarClient: facilitate shutdown
  * [9270717] MT#63171 SystemDSM: use AmEventQueueThread
  * [2245d59] MT#63171 AmThreadWatcher: stop thread
  * [adf2332] MT#62181 support testing under valgrind
  * [c85a2a5] MT#62181 support valgrind leak check
  * [c247242] MT#63171 XMLRPC2DI: proper shutdown
  * [35e1538] MT#63171 XMLRPC2DI: fix dtor ordering
  * [e30510b] MT#63171 AmPlugIn: fix reference counting
  * [de72ac3] MT#63171 stop main wheeltimer at shutdown
  * [06387f3] MT#63171 tcp: join threads after stop
  * [bb4c810] MT#63171 refcount registerApplication
  * [b1f5764] MT#62181 decrease app refcounts on shutdown
  * [9c2b865] MT#62181 add dlhandle wrapper class
  * [35793aa] MT#62181 AmApi: use macro for export func
  * [f6c49b8] MT#62181 update FactoryCreate prototype
  * [4f9066c] MT#62181 remove unused macros
  * [6245e8d] MT#62181 fix basic test
  * [af4814a] MT#62181 actually report test failures
  * [3f20758] MT#62181 add RegisterCache stop/join
  * [5275314] MT#62181 add wheeltimer dtor
  * [bece83b] MT#62181 remove singleton dispose method
  * [f1bc12e] MT#62181 use reference for tcp_server_worker
  * [69a9abd] MT#62181 tcp_trsp: use deque container
  * [daf2f95] MT#62181 use deque to contain sockets and servers
  * [ce39e41] MT#62181 rework singleton
  * [e0804ab] MT#62181 remove underscore from private member
  * [21f38c5] MT#62181 use containers for server objects
  * [2205da5] MT#62181 use shared_ptr for refcounting sockets
  * [1bf5c7e] MT#62181 tcp/tls: use shared_ptr internally
  * [8083dcd] MT#62181 use shared_ptr for msg_logger
  * [5c455d3] MT#62181 wheeltimer: prevent double free

  [ Guillem Jover ]
  * [b7494cf] MT#63051 debian: Fix make variable usage
  * [22e824a] MT#63051 debian: Improve makefile coding style
  * [164b57f] MT#33054 Add .gitignore files
  * [66111e7] MT#33054 Use system libgsm instead of embedded code copy
  * [268e3b3] MT#33054 Use system librtmp instead of embedded code copy
  * [ca2ff68] MT#62181 build: Add missing - for -std= option

  [ Donat Zenichev ]
  * [7d7780a] MT#63071 AmEventDispatcher: imcomplete OR
  * [f94da13] MT#63071 AmEventDispatcher: queues_mut use lock guard
  * [b38c51f] MT#63071 AmEventDispatcher: id_lookup_mut use lock guard
  * [572ed18] MT#63071 AmEventDispatcher: refactor spaces
  * [e3783f1] MT#63071 AmSessionContainer: use static_cast for up-cast
  * [19a6502] MT#63071 AmSessionContainer: refactor spaces
  * [d20c14f] MT#63071 AmSession: add a snapshot mechanism
  * [3b61150] MT#63071 AmEventDispatcher: provide exposed queue lock
  * [5e4235a] MT#62859 AmB2BSession: acceptPendingInviteB2B() take const
  * [2616037] MT#62859 AmB2BSession: treat SDP as const
  * [b5ce83d] MT#62859 CallLeg: set sip replay to false (reconnect)
  * [e4f6f14] MT#62859 CallLeg: store pending updates for non-sip-relayable
  * [cb8e0ec] MT#62859 AmB2BSession: set_sip_relay_only() add logs
  * [2cdd0a6] MT#62859 AmB2BSession::onB2BEvent send fake SDP answer
  * [3b94b6d] MT#59962 Aling the AmOfferAnswer model
  * [5bb0427] MT#62859 AmB2BSession::acceptPendingInviteB2B use local conn/port
  * [ef86e68] MT#62859 AmB2BSession::acceptPendingInviteB2B improve logs
  * [458f4b7] MT#62876 Call transfer: force reconnected to rtp direct
  * [d4200b6] MT#63298 AmB2BSession: introduce `addFakeSDPbasedOnPort()`
  * [e4e1742] MT#63298 AmB2BSession: introduce `getMediaPort()`
  * [fc6c3da] MT#63298 Properly set SDP answer port on call pick-up
  * [f2c1db5] MT#63298 AmOfferAnswer: add support of PreviewCompleted
  * [e005af4] MT#63298 AmOfferAnswer: follow-up for f2c1db55a6a92ae
  * [50b7bc2] MT#59962 AmSdp::parse(): always check return value
  * [34e6b76] MT#59962 AmOfferAnswer: no need to parse CSTA body
  * [d53e757] MT#59962 AmB2BSession: acceptPendingInviteB2B() check body
  * [fccc51a] MT#59962 AmPlugIn: Move shared ptr instead of copying
  * [7f803a2] MT#59962 Edit README preamble
  * [a7a66c7] MT#59962 Rework AmSdp parsing and func users accordingly
  * [0bb3283] MT#59962 Rework AmMimeBody payload to be string
  * [f9ea22f] MT#59962 AmMimeBody: add Content-Length parsing
  * [c19ae58] MT#59962 SBCCallLeg: skip filtering SDP body if Ct.L. empty
  * [31c3090] MT#59962 Fix typo introduced by f9ea22fcc7a763d
  * [c2524be] MT#59962 Add support of AmRtpSocket
  * [257fcd3] MT#59962 Add support of AmIceCandidate


=== pkg/deb/debian/changelog ===
sems (1.6.0) unstable; urgency=low

  * SEMS 1.6.0 release

 -- stefan <stefan.sayer@googlemail.com>  Tue, 16 Jun 2015 13:10:56 +0200

sems (1.6.0~dev) unstable; urgency=medium

  * Devel version

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Thu, 03 Apr 2014 17:52:53 +0200

sems (1.5.0) maverick; urgency=low

  * Core
    - configurable SIP timers (global)
    - timer C support (mainly for SBC)
    - SUBSCRIBE/NOTIFY support
    - multi-mime bodies
    - wideband / multiple sample frequency support
    - multiple destinations (faked SRV record)
    - DNS SRV: support for 503 replies
    - multi-threaded RTP receiver
    - complete rework of offer/answer mechanisms

  * Codecs:
    - iSAC
    - SILK
    - SPEEX 16kHz, 32kHz
    - G722
    - L16

  * SBC
    - audio & dtmf transcoder
    - call-control modules
    - lots of small improvements

  * Monitoring
    - munin plugin

  * DSM
    - mod_xml: XML handling
    - mod_curl: HTTP requests
    - mod_subscription: SUBSCRIBE/NOTIFY
    - mod_regex: regular expressions
    - lots of small improvements

  * App Plug-ins
    - db_reg_agent: register SIP accounts from a DB
    - rtmp: RTMP gateway

 -- Raphael Coeffic <rco@iptel.org>  Tue, 03 Jul 2012 15:06:08 +0200

sems (1.4.0) maverick; urgency=low

  * SEMS 1.4.0 release

 -- Stefan Sayer <stefan.sayer@frafos.com>  Tue, 15 Mar 2011 11:13:05 +0100

sems (1.3.0) unstable; urgency=low

   * 100rel (PRACK) support
   * DNS cache, lb on SRV records 
   * B2B with Session Timer
   * json-rpc v2 module
   * SIP stack moved into core
   * optimizations, especially for signaling
   * many DSM improvements 

 --  Stefan Sayer <stefan.sayer@frafos.com>  Sun, 26 Sep 2010 17:35:22 -0400

sems (1.2.0) unstable; urgency=low

  * SEMS 1.2.0 release

 -- Stefan Sayer <stefan.sayer@frafos.com>  Tue, 30 Mar 2010 21:46:39 +0200

sems (1.1.1) unstable; urgency=low

  * SEMS 1.1.1 bugfix release   - fixed Via HF missing the port number
    in ACK to 200 reply  - do not try to scale too short RTP packets  -
    fixed initialization of SSL - caused random crashing of xmlrpc
    server  - fix size() for AmArg struct type  - authenticate on both
    401 and 407 reply in click2dial  - fixed ssl build dependency for
    DIAMETER client in deb

 -- Stefan Sayer <stefan.sayer@frafos.com>  Tue, 07 Jul 2009 15:13:24 +0200

sems (1.1.0-1) unstable; urgency=low

  * DSM state machine scripting (it's cool!)
  * an (experimental) ISDN gateway module
  * binrpc: MT (SER->) and connection pool (->SER)
  * MT xmlrpc server
  * controlled server shutdown
  * improved logging
  * g722 in 8khz compat mode
  * out of dialog request handling for modules & dialogs without
    sessions
  * audio file autorewind, AmAudio mixing
  * SIP and media IP separately configurable
  * UID/DID support for voicemail/-box/annrecorder
  * and quite some bugs and mem leaks fixed, documentation, etc. 

 -- Stefan Sayer <sayer@iptel.org>  Tue, 20 Jan 2009 18:11:25 +0100

sems (1.1.0-0rc1) unstable; urgency=low

  * Debian Release Candidate 1 for 1.1.

 -- Stefan Sayer <sayer@iptel.org>  Mon, 8 Dec 2008 23:01:40 +0200

sems (1.0.0-0pre1-r856M) unstable; urgency=low

  * Debian Release Candidate 1 for 1.0.

 -- Stefan Sayer <sayer@iptel.org>  Sun, 2 Mar 2002 23:41:31 +0200

=== debian/control ===
Source: ngcp-sems
Section: net
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Homepage: https://www.sipwise.com/
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 flite-dev,
 libbcg729-dev,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libev-dev,
 libevent-dev (>= 2.1.12),
 libgsm1-dev,
 libhiredis-dev,
 libmysql++-dev,
 libopus-dev,
 libre2-dev,
 librtmp-dev,
 libspandsp-dev,
 libspeex-dev,
 libssl-dev,
 libsystemd-dev,
 libxml2-dev,
 openssl,
 pkgconf,
 python3,
 python3-dev,

Package: ngcp-sems
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 adduser,
 ngcp-prompts,
 ngcp-system-tools,
 python3,
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 sems,
Replaces:
 sems,
Description: SIP Express Media Server, very fast and flexible SIP media server
 SEMS, the SIP Express Media Server, is a free, high performance, extensible media
 server for SIP (RFC3261) based VoIP  services. It features voicemail, conferencing,
 announcements, pre-call announcements, prepaid service, calling card service etc.

=== pkg/deb/debian/control ===
Source: sems
Section: net
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Victor Seva <linuxmaniac@torreviejawireless.org>
Build-Depends: debhelper (>= 9~),
               flite-dev,
               libcurl4-openssl-dev | libcurl4-gnutls-dev,
               libev-dev,
               libevent-dev (>= 2.0.0),
               libhiredis-dev,
               libmysql++-dev,
               libspandsp-dev,
               libspeex-dev,
               libssl-dev,
               libxml2-dev,
               openssl,
               python-dev,
               python-sip-dev
Standards-Version: 3.9.5

Package: sems
Architecture: any
Depends: adduser, python, ${misc:Depends}, ${shlibs:Depends}
Description: SIP Express Media Server, very fast and flexible SIP media server
 SEMS, the SIP Express Media Server, is a free, high performance,
 extensible media server and SBC for SIP (RFC3261) based VoIP  services. It
 features voicemail, conferencing, announcements, pre-call announcements,
 prepaid service, calling card service etc.

Package: sems-dbg
Architecture: any
Section: debug
Priority: extra
Depends: sems (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for Sems SIP Express Media Server
 SEMS, the SIP Express Media Server, is a free, high performance,
 extensible media server and SBC for SIP (RFC3261) based VoIP  services. It
 features voicemail, conferencing, announcements, pre-call announcements,
 prepaid service, calling card service etc.
 .
 This package contains the debugging sysmbols.

Package: libsems1-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: development files for SIP Express Media Server
 SEMS, the SIP Express Media Server, is a free, high performance,
 extensible media server and SBC for SIP (RFC3261) based VoIP  services. It
 features voicemail, conferencing, announcements, pre-call announcements,
 prepaid service, calling card service etc.
 .
 This package contains the files needed to compile sems applications.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE = 1

EXCLUDED_MODULES = \
	conf_auth \
	examples/db_announce \
	fast_ack \
	gateway \
	ivr \
	mailbox \
	mp3 \
	pin_collect \
	twit \
	webconference \
	# EOL
EXCLUDED_DSM_MODULES = \
	mod_aws \
	mod_py \
	# EOL
EXCLUDED_DSM_PY_MODULES = \
	mod_aws \
	mod_py \
	# EOL

export DEB_CPPFLAGS_APPEND = -DHAVE_XMLRPCPP_SSL

export APP_NAME = ngcp-sems
export PYTHON_VERSION = 3
export SYSTEM_SAMPLECLOCK_RATE = 48000LL
export LONG_DEBUG_MESSAGE = yes
export USE_THREADPOOL = yes
export USE_SPANDSP = yes


# Enable parallel builds for overrides.
NUMJOBS = 1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE) \
		cfg_target=/etc/$(APP_NAME)/ prefix=/usr \
		exclude_app_modules="$(EXCLUDED_MODULES)" \
		exclude_dsm_modules="$(EXCLUDED_DSM_MODULES)" \
		DESTDIR=$(CURDIR)/debian/$(APP_NAME)

override_dh_auto_install:
	$(MAKE) -C core/ install \
		DESTDIR=$(CURDIR)/debian/$(APP_NAME) \
		prefix=/usr \
		cfg_target=/etc/$(APP_NAME)/

	$(MAKE) -C apps/ install \
		exclude_app_modules="$(EXCLUDED_MODULES) $(PYTHON_MODULES)" \
		exclude_dsm_modules="$(EXCLUDED_DSM_PY_MODULES)" \
		DESTDIR=$(CURDIR)/debian/$(APP_NAME) \
		prefix=/usr \
		cfg_target=/etc/$(APP_NAME)/

=== pkg/deb/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

PYTHON_MODULES=ivr conf_auth mailbox pin_collect

EXCLUDED_MODULES=gateway examples mp3 twit

EXCLUDED_DSM_MODULES=mod_aws
EXCLUDED_DSM_PY_MODULES=mod_aws mod_py

CPPFLAGS += -DHAVE_XMLRPCPP_SSL

export USE_SPANDSP=yes LONG_DEBUG_MESSAGE=yes CPPFLAGS="$(CPPFLAGS)"

%:
	dh $@

override_dh_auto_build:
	$(MAKE) \
	cfg-target=/etc/sems/ prefix=/usr \
	exclude_app_modules="$(EXCLUDED_MODULES)" \
	exclude_dsm_modules="$(EXCLUDED_DSM_MODULES)" \
	DESTDIR=$(CURDIR)/debian/sems

override_dh_auto_install:
	$(MAKE) -C core/ install \
		DESTDIR=$(CURDIR)/debian/sems \
		prefix=/usr \
		cfg-target=/etc/sems/

	$(MAKE) -C apps/ install \
		exclude_app_modules="$(EXCLUDED_MODULES) $(PYTHON_MODULES)" \
		exclude_dsm_modules="$(EXCLUDED_DSM_PY_MODULES)" \
		DESTDIR=$(CURDIR)/debian/sems \
		prefix=/usr \
		cfg-target=/etc/sems/

override_dh_strip:
	dh_strip --dbg-package=sems-dbg
	# those binaries aren't automatically stripped
	test -r $(CURDIR)/debian/libsems1-dev/usr/include/sems/compat/getarch && \
		strip --remove-section=.comment --remove-section=.note --strip-unneeded \
		$(CURDIR)/debian/libsems1-dev/usr/include/sems/compat/getarch
	test -r $(CURDIR)/debian/libsems1-dev/usr/include/sems/compat/getos && \
		strip --remove-section=.comment --remove-section=.note --strip-unneeded \
		$(CURDIR)/debian/libsems1-dev/usr/include/sems/compat/getos
